/****************/
/* Binary patch */
/****************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define	MAXLINE		255
#define	MAXDATA		0x10000

int main(int argc, char **argv)
{
	FILE	*infp, *outfp, *patchfp, *comfp;
	char	line[MAXLINE];
	int		patchdata[MAXDATA];
	int		stadd,st,ed;
	int		cin,pin;

	int		i;

	if (argc != 5) {
		fprintf(stderr, "Usage: binpt binfile patchfile commandfile outfile\n");
		exit(1);
	}

/* open files */

	if ((infp = fopen(argv[1], "rb")) == NULL) {
		perror(argv[1]);
		exit(1);
	}

	if ((patchfp = fopen(argv[2], "rb")) == NULL) {
		perror(argv[2]);
		exit(1);
	}

	if ((comfp = fopen(argv[3], "r")) == NULL) {
		perror(argv[3]);
		exit(1);
	}

	if ((outfp = fopen(argv[4], "wb")) == NULL) {
		perror(argv[4]);
		exit(1);
	}

	for (i = 0;i < MAXDATA;i ++) {
		patchdata[i] = 0;
	}

	if ( fgets(line, MAXLINE, comfp) != NULL) {
		sscanf(line,"0x%x",&stadd);
	}

	while ( fgets(line, MAXLINE, comfp) != NULL) {
		sscanf(line,"0x%x-0x%x",&st,&ed);
		for (i = st-stadd;i <= ed-stadd;i ++) {
			patchdata[i] = 1;
		}
	}

	for (i = 0;;i ++) {
		cin = fgetc(infp);
		pin = fgetc(patchfp);
		if (cin == EOF && pin == EOF) {
			break;
		}
		if (cin == EOF) {
			cin = 0x00;
		}
		if (pin == EOF) {
			pin = 0x00;
		}
		fputc( (patchdata[i] == 0 ? cin : pin), outfp );
	}



	fclose(infp);
	fclose(outfp);
	fclose(patchfp);
	fclose(comfp);


	return(0);
}
